<!-- 社会安保力量 -->
<script setup>
import * as MOSTY from "@/components/MyComponents/index";
import * as rule from "@/utils/rules.js";
import {
  getTbJcglShabll,
  addTbJcglShabll,
  putTbJcglShabll,
  infoTbJcglShabll,
  delTbJcglShabll
} from "@/api/basicsmanage/socialSecurity.js";
import { selectDeptPage } from "@/api/user-manage";
import { ref, getCurrentInstance, onMounted } from "vue";
const { proxy } = getCurrentInstance();
const { D_ZDY_ABLLLX } = proxy.$dict("D_ZDY_ABLLLX");
const keyCount = ref(0); //tabel组件刷新值
const form = ref({}); //新增表单
const tableData = ref([]); //表格数据
const cascader = ref(null);
const total = ref(0);
const chackAdd = ref(false); //新增修改切换
const loading = ref(false); //新增保存按钮截流
const ids = ref([]); //表格选中id集合
const searchBox = ref(null); //搜索盒子
const loadingTable = ref(true); //表格加载状态
const tableHeight = ref(); // 表格高度
const dialogFormVisible = ref(false);
const title = ref("新增社会安保"); //弹窗标题
const elform = ref(null); //新增表单容器
const depList = ref([]); //部门数据
//级联选择器配置
const props = {
  expandTrigger: "children",
  children: "childDeptList",
  label: "orgName",
  value: "id",
  checkStrictly: true,
  emitPath: false
};
const listQuery = ref({
  pageCurrent: 1,
  pageSize: 10
}); //搜索表单
//表单验证
const rules = ref({
  xm: [{ required: true, message: "请输入姓名", trigger: "change" }],
  lxdh: [{ required: true, message: "请输入联系电话", pattern: /^((0\d{2,3}-\d{7,8})|(1[345678]\d{9}))$/, trigger: "change" }],
  ...rule.identityCardRule(
    {
      require: true,
      message: "请输入身份证号",
      validator: true
    },
    "sfzh"
  ) //身份证校验
});
//查询条件选择部门
function handleChange(e) {
  let data = cascader.value.getCheckedNodes();
  form.value.ssbm = data[0].text;
  const ids = JSON.parse(JSON.stringify(e));
  form.value.ssbmdm = ids;
}
// 获取列表
function getListData() {
  loadingTable.value = true;
  getTbJcglShabll(listQuery.value).then((res) => {
    tableData.value = res.records;
    total.value = res.total;
    loadingTable.value = false;
  }).catch(()=>{
    loadingTable.value = false;
  });
}
//打开新增弹窗
function add() {
  chackAdd.value = true;
  dialogFormVisible.value = true;
}

//关闭弹窗
function close() {
  dialogFormVisible.value = false;
  form.value = {};
}
//提交
function submit() {
  elform.value.validate((valid) => {
    if (valid) {
      form.value.ssbmid = form.value.ssbmdm
      loading.value = true;
      setTimeout(() => {
        loading.value = false;
      }, 1500);
      if (chackAdd.value) {
        addTbJcglShabll(form.value).then(() => {
          proxy.$message({
            type: "success",
            message: "新增成功"
          });
          close();
          getListData();
        });
      } else {
        putTbJcglShabll(form.value).then(() => {
          proxy.$message({
            type: "success",
            message: "修改成功"
          });
          close();
          getListData();
        });
      }
    }
  });
}
//修改
function update(row) {
  infoTbJcglShabll(row.id).then((res) => {
    chackAdd.value = false;
    title.value = "修改社会安保";
    dialogFormVisible.value = true;
    form.value = res;
  });
}
//批量数据
const handleSelectionChange = (val) => {
  ids.value = [];
  if (val) {
    val.forEach((item) => {
      ids.value.push(item.id);
    });
  }
};
//删除
function delDictItem(row) {
  proxy
    .$confirm("确定要删除", "警告", {
      type: "warning"
    })
    .then(() => {
      delTbJcglShabll([row.id]).then(() => {
        proxy.$message({
          type: "success",
          message: "删除成功"
        });
        getListData();
      });
    })
    .catch(() => {
      proxy.$message.info("已取消");
    });
}
//批量删除
function batchDelete() {
  proxy
    .$confirm("确定要删除", "警告", {
      type: "warning"
    })
    .then(() => {
      delTbJcglShabll(ids.value).then((res) => {
        proxy.$message({
          message: "删除成功",
          type: "success"
        });
        getListData();
      });
    })
    .catch(() => {
      proxy.$message.info("已取消");
    });
}
//点击查询
const handleFilter = () => {
  listQuery.value.pageCurrent = 1;
  getListData();
};
//点击重置
const reset = () => {
  listQuery.value = {
    pageCurrent: 1,
    pageSize: 10
  };
  getListData();
};
// 表格高度计算
const tabHeightFn = () => {
 tableHeight.value = window.innerHeight - searchBox.value.offsetHeight - 240;
};
/**
 * pageSize 改变触发
 */
const handleSizeChange = (currentSize) => {
  listQuery.value.pageSize = currentSize;
  getListData();
};

/**
 * 页码改变触发
 */
const handleCurrentChange = (currentPage) => {
  listQuery.value.pageCurrent = currentPage;
  getListData();
};
onMounted(() => {
  getListData();
  tabHeightFn();
  window.onresize = function () {
    tabHeightFn();
  };
  selectDeptPage({}).then((res) => {
    depList.value = res.records;
  });
  proxy.mittBus.on("mittFn", (data) => {
    keyCount.value = data;
  });
});
</script>
    
    
<template>
  <div>
    <div class="titleBox">
      <div class="title">社会安保力量</div>
      <div class="btnBox">
        <el-button type="primary" @click="add">
          <el-icon style="vertical-align: middle">
            <CirclePlus />
          </el-icon>
          <span style="vertical-align: middle">新增</span>
        </el-button>
        <el-button
          @click="batchDelete"
          :disabled="ids.length == 0"
          typeof="danger"
        >
          <el-icon style="vertical-align: middle">
            <Delete />
          </el-icon>
          <span style="vertical-align: middle">批量删除</span>
        </el-button>
      </div>
    </div>
    <div class="searchBox" ref="searchBox">
      <el-form :model="listQuery" :inline="true">
        <el-form-item label="所属辖区">
          <MOSTY.Department
            width="100%"
            clearable
            v-model="listQuery.ssbmid"
          />
        </el-form-item>
        <el-form-item label="安保人员">
          <el-input
            v-model="listQuery.xm"
            placeholder="请输入安保人员姓名"
            clearable
          ></el-input>
        </el-form-item>
        <el-form-item label="安保力量类型" prop="ablllx">
          <el-select
            v-model="listQuery.ablllx"
            style="width: 100%"
            placeholder="请选择"
          >
            <el-option
              v-for="dict in D_ZDY_ABLLLX"
              :key="dict.value"
              :value="dict.value"
              :label="dict.label"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <el-button @click="handleFilter"> 查询 </el-button>
          <el-button @click="reset()"> 重置 </el-button>
        </el-form-item>
      </el-form>
    </div>
    <div class="tabBox">
      <el-table
        :data="tableData"
        border
        row-key="id"
        :tree-props="{ children: 'itemList', hasChildren: true }"
        style="width: 100%"
        :key="keyCount"
        :height="tableHeight"
        v-loading="loadingTable"
        element-loading-background="rgba(0,0,0,0.3)"
        element-loading-text="数据加载中。。"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="40" align="center" />
        <el-table-column label="序号" type="index" align="center" width="60" />
        <el-table-column
          sortable
          show-overflow-tooltip
          label="姓名"
          prop="xm"
          align="center"
          width="180"
        />
        <el-table-column
          show-overflow-tooltip
          label="所属辖区"
          prop="ssbm"
          align="center"
        />
        <el-table-column
          show-overflow-tooltip
          label="安保力量类型"
          prop="ablllx"
          align="center"
        >
          <template #default="{ row }">
            <div>
              <dict-tag
                :options="D_ZDY_ABLLLX"
                :value="row.ablllx"
                :tag="false"
              ></dict-tag>
            </div>
          </template>
        </el-table-column>
        <el-table-column label="工作单位" prop="gzdw" align="center" />
        <el-table-column label="联系电话" prop="lxdh" align="center" />

        <el-table-column
          label="操作"
          align="center"
          fixed="right"
          width="140px"
        >
          <template #default="{ row }">
            <el-button @click="update(row)" size="small">修改</el-button>
            <el-button @click="delDictItem(row)" type="danger" size="small"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="fenye" :style="{ top: tableHeight + 'px' }">
        <el-pagination
          class="pagination"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :current-page="listQuery.pageCurrent"
          :page-sizes="[10, 20, 50, 100]"
          :page-size="listQuery.pageSize"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total"
        >
        </el-pagination>
      </div>
    </div>
    <div class="dialog" v-if="dialogFormVisible">
      <div class="head_box">
        <span class="title">{{ title }}</span>
        <div>
          <el-button
            :loading="loading"
            type="primary"
            size="small"
            @click="submit"
            >保存</el-button
          >
          <el-button size="small" @click="close">关闭</el-button>
        </div>
      </div>
      <el-form
        ref="elform"
        :model="form"
        :rules="rules"
        :inline="true"
        label-position="top"
      >
        <el-form-item label="所属辖区" prop="ssbmdm">
           <MOSTY.Department
            width="100%"
            clearable
            :placeholder="form.ssbm"
            v-model="form.ssbmdm"
          />
        </el-form-item>
        <el-form-item label="姓名" prop="xm">
          <el-input v-model="form.xm" placeholder="请输入姓名"></el-input>
        </el-form-item>
        <el-form-item label="身份证号" prop="sfzh">
          <el-input v-model="form.sfzh" placeholder="请输入身份证号"></el-input>
        </el-form-item>
        <el-form-item label="性别" prop="xbdm">
          <MOSTY.PackageSelect
            width="100%"
            v-model="form.xbdm"
            dictEnum="GENDER"
            clearable
            filterable
          />
        </el-form-item>
        <el-form-item label="安保力量类型" prop="ablllx">
          <el-select
            v-model="form.ablllx"
            style="width: 100%"
            placeholder="请选择"
          >
            <el-option
              v-for="dict in D_ZDY_ABLLLX"
              :key="dict.value"
              :value="dict.value"
              :label="dict.label"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="联系电话" prop="lxdh">
          <el-input v-model="form.lxdh" placeholder="请输入联系电话"></el-input>
        </el-form-item>
        <el-form-item label="民族" prop="mzdm">
          <MOSTY.PackageSelect
            width="100%"
            v-model="form.mzdm"
            dictEnum="NATION"
            clearable
            filterable
          />
        </el-form-item>
        <el-form-item label="学历" prop="xldm">
          <MOSTY.PackageSelect
            width="100%"
            v-model:modelValue="form.xldm"
            dictEnum="EDUCATION"
            clearable
            filterable
          />
        </el-form-item>
        <el-form-item style="width: 48%" label="住址详址" prop="zzxz">
          <el-input v-model="form.zzxz" placeholder="请输入住址详址"></el-input>
        </el-form-item>
        <el-form-item style="width: 48%" label="工作单位" prop="gzdw">
          <el-input v-model="form.gzdw" placeholder="请输入工作单位"></el-input>
        </el-form-item>
        <el-form-item style="width: 48%" label="所在单位" prop="szdw">
          <el-input v-model="form.szdw" placeholder="请输入所在单位"></el-input>
        </el-form-item>
        <el-form-item style="width: 48%" label="工作内容" prop="gznr">
          <el-input v-model="form.gznr" placeholder="请输入工作内容"></el-input>
        </el-form-item>
        <el-form-item style="width: 48%" label="掌握技能" prop="zwjn">
          <el-input v-model="form.zwjn" placeholder="请输入掌握技能"></el-input>
        </el-form-item>
        <el-form-item prop="bz" label="备注" style="width: 100%">
          <el-input
            v-model="form.bz"
            placeholder="请输入关键字"
            show-word-limit
            type="textarea"
          />
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>
<style lang='scss' scoped>
@import "~@/assets/css/layout.scss";
@import "~@/assets/css/element-plus.scss";
</style>